/*
Copyright (c) Daybrush
name: vue-infinite-viewer
license: MIT
author: Daybrush
repository: https://github.com/daybrush/infinite-viewer/blob/master/packages/vue-infinite-viewer
version: 0.11.1-beta.1
*/
'use strict';

var VanillaInfiniteViewer = require('infinite-viewer');
var utils = require('@daybrush/utils');
var vue = require('@vue/compat');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var methods = {};
VanillaInfiniteViewer.METHODS.forEach(function (name) {
  methods[name] = function () {
    var _a;

    var args = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }

    (_a = this.infiniteViewer)[name].apply(_a, args);
  };
});
var script = {
  methods: methods,
  props: VanillaInfiniteViewer.OPTIONS,
  a: 1,
  mounted: function () {
    var _this = this;

    var options = {};
    var props = this.$props;
    VanillaInfiniteViewer.OPTIONS.forEach(function (name) {
      var value = props[name];

      if (!utils.isUndefined(value)) {
        options[name] = props[name];
      }
    });
    var refs = this.$refs;
    this.infiniteViewer = new VanillaInfiniteViewer(refs.containerElement, refs.scrollAreaElement.nextElementSibling, __assign(__assign({}, options), {
      wrapperElement: refs.wrapperElement,
      scrollAreaElement: refs.scrollAreaElement,
      horizontalScrollElement: refs.horizontalScrollElement,
      verticalScrollElement: refs.verticalScrollElement
    }));
    var infiniteViewer = this.infiniteViewer;
    VanillaInfiniteViewer.EVENTS.forEach(function (name) {
      infiniteViewer.on(name, function (e) {
        _this.$emit(name, __assign({}, e));
      });
    });
  },
  updated: function () {
    var props = this.$props;
    var infiniteViewer = this.infiniteViewer;
    VanillaInfiniteViewer.PROPERTIES.forEach(function (name) {
      var value = props[name];

      if (infiniteViewer[name] !== value && !utils.isUndefined(value)) {
        infiniteViewer[name] = props[name];
      }
    });
  },
  beforeDestroy: function () {
    this.infiniteViewer.destroy();
  },
  unmounted: function () {
    this.infiniteViewer.destroy();
  }
};

const _hoisted_1 = {
  ref: "wrapperElement"
};
const _hoisted_2 = {
  ref: "scrollAreaElement"
};
const _hoisted_3 = {
  ref: "horizontalScrollElement"
};

const _hoisted_4 =
/*#__PURE__*/
vue.createVNode("div", {
  class: "infinite-viewer-scroll-thumb"
}, null, -1
/* HOISTED */
);

const _hoisted_5 = {
  ref: "verticalScrollElement"
};

const _hoisted_6 =
/*#__PURE__*/
vue.createVNode("div", {
  class: "infinite-viewer-scroll-thumb"
}, null, -1
/* HOISTED */
);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  return vue.openBlock(), vue.createBlock("div", {
    class: _ctx.className || _ctx.defaultClassName,
    ref: "containerElement"
  }, [vue.createVNode("div", _hoisted_1, [vue.createVNode("div", _hoisted_2, null, 512
  /* NEED_PATCH */
  ), vue.renderSlot(_ctx.$slots, "default")], 512
  /* NEED_PATCH */
  ), vue.createVNode("div", _hoisted_3, [_hoisted_4], 512
  /* NEED_PATCH */
  ), vue.createVNode("div", _hoisted_5, [_hoisted_6], 512
  /* NEED_PATCH */
  )], 2
  /* CLASS */
  );
}

script.render = render;
script.__file = "src/InfiniteViewer.vue";

// import VueInfiniteViewer from './VueInfiniteViewer';

var modules = ({
    __proto__: null,
    'default': script,
    VueInfiniteViewer: script
});

for (var name in modules) {
  script[name] = modules[name];
}

module.exports = script;
//# sourceMappingURL=infinite-viewer.cjs.js.map
